=== debian/changelog ===
libquotient (0.8.2-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix erroneous change of maintainer in last upload. Apologies.

 -- Simon Quigley <tsimonq2@debian.org>  Thu, 27 Feb 2025 15:41:18 -0600

libquotient (0.8.2-1.2) unstable; urgency=medium

  [ Rik Mills ]
  * debian/rules: Don't fail on removing debian/tmp/usr/bin/quotest if
    this was not produced by the build (i.e. on riscv64 in Ubuntu).

  [ Simon Quigley ]
  * Non-maintainer upload (Closes: #1095595).

 -- Simon Quigley <tsimonq2@debian.org>  Thu, 27 Feb 2025 14:12:22 -0600

libquotient (0.8.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable. (Closes: #1074110, #1089827)

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Dec 2024 09:50:39 +0100

libquotient (0.8.2-1) experimental; urgency=medium

  * New upstream release.
  * Build with Qt6.

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 15 Aug 2024 20:25:43 -0400
