=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
Build-Depends:
  debhelper-compat (= 12),
  cmake,
  libolm-dev,
  libssl-dev,
  qt6-base-dev,
  qt6-multimedia-dev,
  qtkeychain-qt6-dev,
  libqt6sql6-sqlite
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git
Vcs-Browser: https://salsa.debian.org/matrix-team/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libquotientqt6-0.8 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.

Package: libquotientqt6-0.8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.
