=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1 -DQuotient_ENABLE_E2EE=1 -DBUILD_WITH_QT6=1

override_dh_auto_install:
	dh_auto_install
# unused example file -- remove to avoid warning from dh_missing
	rm -f debian/tmp/usr/bin/quotest

override_dh_auto_test:
# testolmaccount needs a local synapse running, so skip it
# testverification writes to home directory, so make a dummy home directory for it
	mkdir debian/dummyhome
	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
	rm -rf debian/dummyhome
