=== debian/changelog ===
libquotient (0.9.1-0ubuntu1) plucky; urgency=medium

  * New upstream release (0.9.1). Required for latest KDE neochat.
  * Update build deps.
  * Rename library package according to SONAME bump. 0.8 to 0.9

 -- Rik Mills <rikmills@ubuntu.com>  Fri, 22 Nov 2024 10:36:04 +0000

libquotient (0.8.2-1ubuntu1) plucky; urgency=medium

  * debian/rules: Don't fail on removing debian/tmp/usr/bin/quotest if
    this was not produced by the build (i.e. on riscv64 in Ubuntu).

 -- Rik Mills <rikmills@kde.org>  Tue, 29 Oct 2024 19:45:58 +0000
