=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libquotient
 Priority: optional
-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
 Build-Depends:
   debhelper-compat (= 12),
@@ -8,6 +9,7 @@
   libolm-dev,
   libssl-dev,
   qt6-base-dev,
+  qt6-base-private-dev,
   qt6-multimedia-dev,
   qtkeychain-qt6-dev,
   libqt6sql6-sqlite
@@ -20,12 +22,12 @@
 Package: libquotient-dev
 Section: libdevel
 Architecture: any
-Depends: libquotientqt6-0.8 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
+Depends: libquotientqt6-0.9 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
 Description: Qt6 library to write cross-platform clients for Matrix
  libQuotient is a Qt6-based library to make IM clients for the Matrix
  protocol. It is the backbone of Quaternion, NeoChat and some other projects.
 
-Package: libquotientqt6-0.8
+Package: libquotientqt6-0.9
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Qt6 library to write cross-platform clients for Matrix
