## libquotient 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.1" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})
 
@@ -190,6 +190,7 @@
         Quotient/events/keyverificationevent.h
         Quotient/keyimport.h
         Quotient/qt_connection_util.h
+        Quotient/thread.h
     PRIVATE
         Quotient/function_traits.cpp
         Quotient/networkaccessmanager.cpp
@@ -247,6 +248,7 @@
         Quotient/e2ee/cryptoutils.cpp
         Quotient/e2ee/sssshandler.cpp
         Quotient/keyimport.cpp
+        Quotient/thread.cpp
         libquotientemojis.qrc
 )
