=== debian/changelog ===
libquotient (0.9.2-0ubuntu1) plucky; urgency=medium

  * New upstream release.
  * Bump to debhelper 13, Standards-version 4.7.0. No changes needed.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 16 Feb 2025 23:03:28 -0600
