=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
 Build-Depends:
-  debhelper-compat (= 12),
+  debhelper-compat (= 13),
   cmake,
   libolm-dev,
   libssl-dev,
@@ -13,7 +13,7 @@
   qt6-multimedia-dev,
   qtkeychain-qt6-dev,
   libqt6sql6-sqlite
-Standards-Version: 4.3.0
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/quotient-im/libQuotient
 Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git
