=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,5 @@
 # testolmaccount needs a local synapse running, so skip it
 # testverification writes to home directory, so make a dummy home directory for it
 	mkdir debian/dummyhome
-	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
+	-HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
 	rm -rf debian/dummyhome
