## libquotient 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.3" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})
