=== debian/changelog ===
libquotient (0.9.3-4) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 0.9.3.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 13 Aug 2025 11:33:29 +0200

libquotient (0.9.3-3) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 12 Aug 2025 07:55:22 +0200

libquotient (0.9.3-2) experimental; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 0.9.3.
  * Use dh-sequence-pkgkde-symbolshelper for symbols handling.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 12 Apr 2025 23:42:00 +0200

libquotient (0.9.3-1) experimental; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (0.9.3).
  * Update build-deps and deps with the info from cmake.
  * Disable __FILE__ mangling to unbreak tests.
  * Bump library soname to libquotientqt6-0.9.
  * Build with hardening=+all build hardening flag.
  * Adopt the library under the Qt/KDE Team’s maintainership after
    discussing with Hubert Chathi.
  * Bump Standards-Version to 4.7.2, no change required.
  * Remove dh_make template from watch file comments.
  * Add lintian overrides for LGPLv2.1 text using the old FSF address.
  * Add ABI symbols tracking file.
  * Improve package descriptions.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 07 Apr 2025 08:00:25 +0200
