=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Andres Salomon <dilinger@debian.org>,
Build-Depends: debhelper-compat (= 12),
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.26~),
               libolm-dev (>= 3.2.5~),
               libqt6sql6-sqlite,
               libssl-dev (>= 1.1.0~),
               qt6-base-dev (>= 6.4.0~),
               qt6-base-private-dev,
               qt6-multimedia-dev,
               qtkeychain-qt6-dev,
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libolm-dev,
         libquotientqt6-0.9 (= ${binary:Version}),
         libssl-dev (>= 1.1.0~),
         ${misc:Depends},
Description: Qt6 library to write cross-platform clients for Matrix - development files
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.
 .
 This package contains the development files for libQuotient.

Package: libquotientqt6-0.9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.
