=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=-fixfilepath
 
 %:
 	dh $@
@@ -16,5 +18,5 @@
 # testolmaccount needs a local synapse running, so skip it
 # testverification writes to home directory, so make a dummy home directory for it
 	mkdir debian/dummyhome
-	-HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
+	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
 	rm -rf debian/dummyhome
