## libquotient 0.9.4

=== debian/changelog ===
libquotient (0.9.4-0zneon+24.04+noble+stable+build3) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Sat, 13 Sep 2025 02:44:43 +0000

libquotient (0.9.4-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Sat, 13 Sep 2025 12:43:22 +1000

libquotient (0.9.2-0neon) noble; urgency=medium

  [ Jonathan Riddell ]
  * New release

  [ Carlos De Maine ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sat, 22 Feb 2025 07:24:29 +1000
