=== debian/control ===
Source: libquotient
Priority: optional
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Andres Salomon <dilinger@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libolm-dev,
               libqt6sql6-sqlite,
               libssl-dev,
               qt6-base-dev,
               qt6-multimedia-dev,
               qtkeychain-qt6-dev
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://invent.kde.org/neon/forks/libquotient.git
Vcs-Browser: https://invent.kde.org/neon/forks/libquotient
Maintainer: Neon CI <neon@kde.org>

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libolm-dev,
         libquotientqt6-0.9 (= ${binary:Version}),
         libssl-dev,
         ${misc:Depends}
Breaks: libquotient-qt5-dev (<< 0.9), libquotient-qt6-dev (<< 0.9)
Replaces: libquotient-qt5-dev (<< 0.9), libquotient-qt6-dev (<< 0.9)
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.

Package: libquotientqt6-0.9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

Package: libquotient-qt5-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends: libquotient-dev (= ${binary:Version}), ${misc:Depends}
Description: Empty transitional
 Dummy package

Package: libquotient-qt6-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends: libquotient-dev (= ${binary:Version}), ${misc:Depends}
Description: Empty transitional
 Dummy package
