## libquotient 0.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.3" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.5" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})
 
@@ -93,6 +93,10 @@
 
 find_package(${Qt} ${QtMinVersion} REQUIRED Core Network Gui Test Sql)
 get_filename_component(Qt_Prefix "${${Qt}_DIR}/../../../.." ABSOLUTE)
+
+if(${Qt}Core_VERSION VERSION_GREATER_EQUAL 6.10)
+    find_package(${Qt} ${QtMinVersion} REQUIRED COMPONENTS CorePrivate)
+endif()
 
 find_package(${Qt}Keychain REQUIRED)
 
@@ -319,5 +323,3 @@
 
 # Produce the list of all Matrix API files for building the library. When this
 # list changes (normally after calling GTAD), CONFIGURE_DEPENDS will force
-# the build system to call CMake again. Checking for the glob change slows down
-# each build (even if the target does not involve API generation). It would be
