=== debian/changelog ===
libquotient (0.9.5-2) unstable; urgency=medium

  * Team upload.
  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Oct 2025 08:38:55 +0200

libquotient (0.9.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop creating an empty directory as $HOME when running dh_auto_test, as
      debhelper does it automatically
  * Add the configuration for the CI on salsa.
  * Drop the .dirs files, as all the needed directories are automatically
    created by dh_install.
  * Drop debian/gbp.conf, not actually needed.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Update the build dependencies according to the upstream build system:
    - drop qt6-multimedia-dev, not used
  * Drop -DQuotient_ENABLE_E2EE=1 -DBUILD_WITH_QT6=1 from the cmake arguments,
    as they are no more needed.
  * Update symbols file. (Closes: #1114181)
  * Avoid shipping /usr/share/ndk-modules/Android.mk by removing it from
    debian/tmp, as done for other bits
    - drop debian/not-installed, no more needed now
  * Improve the install files to be more specific.
  * Mark libquotientqt6-0.9 as Multi-Arch: same.
  * Add a simple debian/upstream/metadata file.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Oct 2025 06:59:55 +0200
