=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=-fixfilepath

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1

execute_after_dh_auto_install:
# for android
	rm -f debian/tmp/usr/share/ndk-modules/Android.mk
# unused example file
	rm -f debian/tmp/usr/bin/quotest

override_dh_auto_test:
# testolmaccount needs a local synapse running, so skip it
	dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
